SoVRMLMaterial(3)

NAME
SoVRMLMaterial - The SoVRMLMaterial class is used to assign a material to geometry.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLMaterial.h>

Inherits SoNode.

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLMaterial (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFColor diffuseColor
SoSFFloat ambientIntensity
SoSFColor specularColor
SoSFColor emissiveColor
SoSFFloat shininess
SoSFFloat transparency

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLMaterial ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLMaterial class is used to assign a material to geometry. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

Material {
  exposedField SFFloat ambientIntensity  0.2         # [0,1]
  exposedField SFColor diffuseColor      0.8 0.8 0.8 # [0,1]
  exposedField SFColor emissiveColor     0 0 0       # [0,1]
  exposedField SFFloat shininess         0.2         # [0,1]
  exposedField SFColor specularColor     0 0 0       # [0,1]
  exposedField SFFloat transparency      0           # [0,1]
}

The Material node specifies surface material properties for associated geometry nodes and is used by the VRML lighting equations during rendering. Subclause 4.14, Lighting model (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.14), contains a detailed description of the VRML lighting model equations. All of the fields in the Material node range from 0.0 to 1.0. The fields in the Material node determine how light reflects off an object to create colour:

•   The ambientIntensity field specifies how much ambient light from light sources this surface shall reflect. Ambient light is omnidirectional and depends only on the number of light sources, not their positions with respect to the surface. Ambient colour is calculated as ambientIntensity × diffuseColor.

•   The diffuseColor field reflects all VRML light sources depending on the angle of the surface with respect to the light source. The more directly the surface faces the light, the more diffuse light reflects.

•   The emissiveColor field models 'glowing' objects. This can be useful for displaying pre-lit models (where the light energy of the room is computed explicitly), or for displaying scientific data.

•   The specularColor and shininess fields determine the specular highlights (e.g., the shiny spots on an apple). When the angle from the light to the surface is close to the angle from the surface to the viewer, the specularColor is added to the diffuse and ambient colour calculations. Lower shininess values produce soft glows, while higher values result in sharper, smaller highlights.

•   The transparency field specifies how 'clear' an object is, with 1.0 being completely transparent, and 0.0 completely opaque.

Constructor & Destructor Documentation

  SoVRMLMaterial::SoVRMLMaterial (void)
Constructor.

  SoVRMLMaterial::~SoVRMLMaterial () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLMaterial::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLMaterial::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoVRMLMaterial::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLMaterial::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVRMLMaterial::initClass (void) [static]

  void SoVRMLMaterial::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVRMLMaterial::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVRMLMaterial::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Member Data Documentation

  SoSFColor SoVRMLMaterial::diffuseColor
The diffuse color component. Default value is (0.8, 0.8, 0.8).

  SoSFFloat SoVRMLMaterial::ambientIntensity
The ambient intensity. Default value is 0.2.

  SoSFColor SoVRMLMaterial::specularColor
The specular color component. Default value is (0, 0, 0).

  SoSFColor SoVRMLMaterial::emissiveColor
The emissive color component. Default value is (0, 0, 0).

  SoSFFloat SoVRMLMaterial::shininess
The shininess value. A number between 0 and 1. Default value is 0.2.

  SoSFFloat SoVRMLMaterial::transparency
The material transparency. Valid range is from 0.0 (completely opaque) to 1.0 (completely transparent). Default value is 0.0.

Author

Generated automatically by Doxygen for Coin from the source code.